;==============================================================================
    include \masm32\include\masm32rt.inc
    include winio.inc
    includelib winio32.lib
;==============================================================================
printf MACRO format:REQ, args:VARARG
    IFNB <args>
        invoke crt_printf, cfm$(format), args
    ELSE
        invoke crt_printf, cfm$(format)
    ENDIF
    EXITM <>
ENDM
;==============================================================================
    include hexdump.asm
;==============================================================================
    .data
      physStruct PHYSSTRUCT32 <>
    .code
;==============================================================================
start:
;==============================================================================
    invoke InitializeWinIo
    printf( "InitializeWinIo: %d\n", eax )

    mov DWORD PTR physStruct.pvPhysAddress, 0
    mov DWORD PTR physStruct.dwPhysMemSizeInBytes, 4096

    ;----------------------------------------------------------
    ; For some reason, the STDCALL MapPhysToLin function is
    ; removing 8 bytes from the stack, instead of the 4 bytes
    ; that are being passed.
    ;----------------------------------------------------------

    mov eax, esp
    printf( "ESP: %Xh\n", eax )

    invoke MapPhysToLin, ADDR physStruct
    mov ebx, eax

    mov eax, esp
    printf( "ESP: %Xh\n", eax )

    printf( "Linear Address: %Xh\n", ebx )

    ;------------------------------------------
    ; Toggle the byte at 4A1h between 0 and 1.
    ;------------------------------------------

    mov al, [ebx+4a1h]
    .IF al
        mov BYTE PTR [ebx+4a1h], 0
    .ELSE
        mov BYTE PTR [ebx+4a1h], 1
    .ENDIF

    invoke HexAsciiDump, ebx, 4096 / 16, 1

    mov eax, esp
    printf( "ESP: %Xh\n", eax )

    invoke UnmapPhysicalMemory, ADDR physStruct

    mov eax, esp
    printf( "ESP: %Xh\n", eax )

    invoke ShutdownWinIo

    inkey "Press any key to exit..."
    exit
;==============================================================================
end start
