;--------------------------------------------------------------
; The interface macros for GetPortVal and SetPortVal provide a
; more convenient call interface. The function return values
; (true/false) are discarded because, barring a misplaced call
; to ShutdownWinIo, they duplicate the return value for
; InitializeWinIo (See the Ports32.cpp source).
;--------------------------------------------------------------

; THIS FILE HAS ONLY BEEN PARTIALLY CONVERTED TO VERSION 3.0

PHYSSTRUCT32 STRUCT
  dwPhysMemSizeInBytes  QWORD ?
	pvPhysAddress         QWORD ?
	PhysicalMemoryHandle  QWORD ?
	pvPhysMemLin          QWORD ?
	pvPhysSection         QWORD ?
PHYSSTRUCT32 ENDS

InitializeWinIo PROTO SYSCALL
ShutdownWinIo PROTO SYSCALL

GetPortVal PROTO SYSCALL :DWORD,:DWORD,:DWORD
SetPortVal PROTO SYSCALL :DWORD,:DWORD,:DWORD

MapPhysToLin PROTO SYSCALL :DWORD
UnmapPhysicalMemory PROTO SYSCALL :DWORD

GetPhysLong PROTO SYSCALL :DWORD,:DWORD
SetPhysLong PROTO SYSCALL :DWORD,:DWORD

;--------------------------------------------------------------
; InitializeWinIo calls InstallWinIoDriver as necessary,
; so under under Windows NT/2000/XP it will fail if called
; from a non-administrative account. See the Winio.cpp
; source and the WinIo help for more information.
;--------------------------------------------------------------

InstallWinIoDriver PROTO SYSCALL :DWORD,:DWORD
RemoveWinIoDriver PROTO SYSCALL

; ------------------------------
; Byte and word versions only.
; ------------------------------
;
define_dw_port_val MACRO
  IFNDEF _dw_port_val_defined
    .data
      _dw_port_val_ dd ?
    .code
    _dw_port_val_defined equ <1>
  ENDIF
ENDM

inp MACRO port
    define_dw_port_val
    invoke GetPortVal, port, ADDR _dw_port_val_, 1
    mov   eax, _dw_port_val_
    and   eax, 0ffh
    EXITM <eax>
ENDM

inpw MACRO port
    define_dw_port_val
    invoke GetPortVal, port, ADDR _dw_port_val_, 2
    mov   eax, _dw_port_val_
    and   eax, 0ffffh
    EXITM <eax>
ENDM

outp MACRO port,databyte
    invoke SetPortVal, port, databyte, 1
ENDM

outpw MACRO port,dataword
    invoke SetPortVal, port, dataword, 2
ENDM
